SystemOrganization addCategory: #BugFinder!

Object subclass: #BugFinder
	instanceVariableNames: 'generator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BugFinder'!

!BugFinder methodsFor: 'as yet unclassified' stamp: 'GonzaloMunoz 12/14/2011 22:30'!
generator: aRandom
	generator := aRandom.! !

!BugFinder methodsFor: 'as yet unclassified' stamp: 'GonzaloMunoz 12/14/2011 22:28'!
initialize
	generator := Random new.! !

!BugFinder methodsFor: 'as yet unclassified' stamp: 'GonzaloMunoz 12/18/2011 21:55'!
tryUnarySelectors: anInstance probability: aFloat times: anInteger
	"
	Does anInteger runs. Each run, sends anInstance each of its unary messages. Each message
	is sent with probability aFloat. Returns a list of Points of the form ( R @ E ) where E is a list
	of exceptions caught during run R that were not signaled by anInstance.
	"
	| exceptionList run exception point |
	exceptionList := OrderedCollection new.
	run := 0.
	[ run < anInteger ] whileTrue: [
		point := ( run + 1 ) @ ( OrderedCollection new ).
		( ( anInstance class ) selectors select: [ :s | ( s isUnary ) and: [ ( s equalsTo: 'initialize' ) not ] ] ) do: [ :s |
			( generator next < aFloat )
				ifTrue: [
					[ anInstance perform: s ] on: Exception do: [ :ex |
						( ex signaler = anInstance )
							ifFalse: [ point y add: ex ].
					].
				].
		].
		exceptionList add: point.
		run := run + 1.
	].
	^ exceptionList.! !
